



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>JDBC自动提交和批处理操作</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">JDBC自动提交和批处理操作</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-17 00:57:57 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>今天用JDBC与数据库进行交互的时候，报错如下：</p>
<p>********************************************************************************************* <br />com.ibm.db2.jcc.b.SqlException: [jcc][t4][10251][10308][3.53.70] 正在连接上执行事务时，请求了 java.sql.Connection.close()。 <br />事务仍然保持活动状态，不能关闭连接。 ERRORCODE=-4471, SQLSTATE=null <br />at com.ibm.db2.jcc.b.bd.a(bd.java:660) <br />at com.ibm.db2.jcc.b.bd.a(bd.java:60) <br />at com.ibm.db2.jcc.b.bd.a(bd.java:120) <br />at com.ibm.db2.jcc.b.jb.t(jb.java:1105) <br />at com.ibm.db2.jcc.b.jb.w(jb.java:1128) <br />at com.ibm.db2.jcc.b.jb.u(jb.java:1114) <br />at com.ibm.db2.jcc.b.jb.close(jb.java:1098) <br />at com.softtone.excution.Odb.close(Odb.java:192) <br />at com.softtone.excution.Odb.main(Odb.java:219) <br />************************************************************************************************</p>
<p>总结如下:</p>
<p>1.JDBC默认是自动提交的，对于查询可以不用修改设置</p>
<p>2.JDBC中对于增、删、改、查的修改操作，为保持数据的完整性，一般都是把修改操作组装成一个事务。需要在修改之前调用connection对象的setAutoCommit(false)这个方法，在调用完statement对象的executeBatch()批量修改方法后，后面需要跟一个connection对象的commit()方法。否则，在最后调用conn.close()方法关闭连接会抛出事务正在活动，不能关闭JDBC连接的异常。</p>
<p>注：setAutoCommit(false)放在具体的操作里面，一般是修改操作之前。查询操作就不用设置。</p>
<p>示例:</p>
<div>
<pre class="prettyprint linenums">public class JdbcTest {<br />
    public void execute(){<br />
        Connection conn = null;<br />
        Statement stmt = null;<br />
        ResultSet rs = null;<br />
        try {<br />
            conn = JdbcUtil.getConnection(Constants.URL, Constants.USERNAME, Constants.PASSWORD);<br />
            String sqlQuery = "select distinct ID from table a";<br />
            stmt = conn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_UPDATABLE);<br />
            rs = stmt.executeQuery(sqlQuery);<br />
            StringBuffer sb1 = new StringBuffer();<br />
            while(rs.next()){<br />
                sb1.append("'"+rs.getString(1)+"'");<br />
                if(!rs.isLast()){<br />
                    sb1.append(",");<br />
                }<br />
            }<br />
            rs.close();<br />
            String Id = sb1.toString();<br />
            if(!"".equals(Id)){<br />
                //为保持数据的一致性，把多个对数据库的删除操作作为一个事务，禁止自动提交<br />
                conn.setAutoCommit(false);<br />
                String sqlDelete1 = "delete from table1 where ID in (" + Id +")";<br />
                stmt.addBatch(sqlDelete1);<br />
                String sqlDelete2 = "delete from table2 where ID in (" + Id +")";<br />
                stmt.addBatch(sqlDelete2);<br />
                stmt.executeBatch();<br />
                conn.commit();<br />
            }<br />
            stmt.close();<br />
            conn.close();

        } catch (SQLException e) {<br />
            e.printStackTrace();<br />
        }finally{<br />
            JdbcUtil.free(rs, stmt, conn);<br />
        }<br />
    }<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pdpl79.html">【Network】修改docker启动默认网桥docker0为自定义网桥</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8km7579.html">JavaScript创建对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlk2yx8.html">linux 下如何抓取HTTP流量包&lpar;httpry&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn3gk39.html">codeforces  474D&period;Flowers  解题报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnnrrj8.html">js字符串函数之indexOf（）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn5n5d8.html">oracle中的loop与while循环</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v1vkj8.html">c&plus;&plus; 操作注冊表</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e17ydz9.html">J2EE、J2SE、J2ME</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1zjxoq.html">使用spol导出exce</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mepl4pq.html">smarty实例登陆、显示、分页</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k41269.html">JavaScript中的不同逻辑算法结合操作解决实际多重问题以及常用函数类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgk7dm8.html">Python 数据分析Windows环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j7jjo8.html">UVA 548 Tree 建树</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj1m6r9.html">How To Make A Swipeable Table View Cell With Actions &ndash; Without Going Nuts With Scroll Views</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvjeyl8.html">jsp请求java返回pdf、excel与word</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv125r8.html">a file was not found</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o43pj8.html">CentOS 6 安装Redmine</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpj7zl9.html">php分享二十三：字符编码</a>
		</li>
						<li><a href="https://www.batexi.com/a/902dk63q.html">wireshark和RawCap跟踪并解决中文乱码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kolpv7q.html">3&period; Layout -- 1</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8k1zrd69.html">&lbrack;Flux&rsqb; 2&period; Overview and Dispatchers</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y13xeq.html">Instruction （hdu 5083）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1zr3j9.html">springmvc 例</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okr24p9.html">MySQL 一致性读 深入研究    digdeep博客学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdlw0e8.html">计算机体系结构 -内存优化vm&plus;oom</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdyzwy8.html">进程的优先级 与 CFS 进程调度</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm00pk9.html">updatepanel局部刷新功能，实现注册时对用户名的检测</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z17nk39.html">SQL SERVER将指定表中的指定字段按照（&comma;）逗号分隔</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y1vx5q.html">Cacti优化之spine轮询器</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj5rm49.html">Javascript基础&lpar;2&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
